# coded by JayleoPlayGround
# use Portable Python 2.7.5.1 + pywin32-214


import time
import win32ui
import dde
from pywin.mfc import object

#https://pypi.org/project/websocket_client/
import websocket
import time
import sys

import string

class DDETopic(object.Object):
    def __init__(self, topicName):
        self.topic = dde.CreateTopic(topicName)
        object.Object.__init__(self, self.topic)
        self.items = {}

    def setData(self, itemName, value):
        try:
            self.items[itemName].SetData( str(value) )
        except KeyError:
            if itemName not in self.items:
                self.items[itemName] = dde.CreateStringItem(itemName)
                self.topic.AddItem( self.items[itemName] )
                self.items[itemName].SetData( str(value) )


ddeServer = dde.CreateServer()
ddeServer.Create('Orbitron')
ddeTopic = DDETopic('Tracking')
ddeServer.AddTopic(ddeTopic)

mytime=0

def on_message(ws, message):
    #print(message)
    i=0         
    #mymessage=ascii(message)
    for j in message:
        #if j in string.digits or j in string.ascii_letters or j in string.punctuation:
        i=i+1            
        ddeTopic.setData('char'+str(i), j)
        win32ui.PumpWaitingMessages(0,-1)
    ddeTopic.setData('char'+str(i+1), ';')
    win32ui.PumpWaitingMessages(0, -1)    
    #time.sleep(0.1)
    global mytime
    # every second verify is stream enabled
    if time.time()>mytime:
        mytime=time.time()        
        my_file = open("stream_enabled.txt", "r")
        content = my_file.readline(1)
        my_file.close()
        if content == "0":
            ws.keep_running = False

def on_error(ws, error):
    print(error)

def on_close(ws):
    print("### closed ###")

def on_open(ws):
    my_file = open("tickers.txt", "r")
    content = my_file.read()
    content_list = content.split(",")
    my_file.close()
    for contentitem in content_list:
         ws.send('{"type":"subscribe","symbol":"'+contentitem+'"}')

#while True:     
    #yourData='{"data":[{"c":["1","8"],"p":431.63,"s":"SPY","t":1646416466116,"v":100},{"c":["1","8"],"p":431.64,"s":"SPY","t":1646416466116,"v":100},{"c":["1","8","12"],"p":431.64,"s":"SPY","t":1646416466116,"v":28},{"c":["1","12"],"p":163.649,"s":"AAPL","t":1646416465535,"v":1},{"c":["1","12"],"p":163.65,"s":"AAPL","t":1646416465535,"v":1},{"c":["1"],"p":108.745,"s":"AMD","t":1646416466361,"v":100},{"c":["1","12"],"p":2648.025,"s":"GOOG","t":1646416465304,"v":1},{"c":["1","8","12"],"p":431.64,"s":"SPY","t":1646416466116,"v":13},{"c":["1","12"],"p":290.645,"s":"MSFT","t":1646416466354,"v":60},{"c":["1","12"],"p":2648.9996,"s":"GOOG","t":1646416465567,"v":1}],"type":"trade"}'
    #i=0
    #for c in yourData:
        #i=i+1
        #ddeTopic.setData('char'+str(i), c)  
        #win32ui.PumpWaitingMessages(0, -1)          
    #ddeTopic.setData('char'+str(i+1), ';')
    #win32ui.PumpWaitingMessages(0, -1)   
    #time.sleep(0.1)

if __name__ == "__main__":
    websocket.enableTrace(True)
    # sys.argv[1] argument 1 is the token api key
    ws = websocket.WebSocketApp("wss://ws.finnhub.io?token="+sys.argv[1],
                              on_message = on_message,
                              on_error = on_error,
                              on_close = on_close)
    ws.on_open = on_open
    ws.run_forever()